/*
 gcc bmpspd.c cpuidc64.o cpuida64.o -m64 -lrt -lc -lm -O3 -o SDL_bmpspd64 `sdl-config --cflags --libs`
 ./SDL_bmpspd64

 gcc bmpspd.c cpuidc.o cpuida.o -lrt -lc -lm -O3 -o SDL_bmpspd32 `sdl-config --cflags --libs`
 ./SDL_bmpspd32
*/

 #include <SDL/SDL.h>
 #include <SDL/SDL_video.h>
 #include <stdio.h>
 #include <stdlib.h>
 #include <string.h>
 #include <unistd.h>
 #include <sys/stat.h>
 #include <fcntl.h>
 #include <stdint.h>
 #include <dirent.h>
 #include <sys/statvfs.h>
 #include "cpuidh.h"
 #include <mm_malloc.h>

 #define version  "64 Bit Version 1"
//  #define version  "32 Bit Version 1"


int   enlarge(int this1);
int   readBMP(int this1);
int   writeBMP(int this1);
int   displayEnlarged(int this1);
int   scroll(int this1);
int   rotateRead(int this1);
int   memused();
char filePath[PATH_MAX] = "";
char testFile[PATH_MAX];

typedef struct
{
   unsigned short bfType; 
   unsigned int bfSize; 
   unsigned int bfReserved; 
   unsigned int bfOffBits; 
}
__attribute__((packed))BMPHDR;

BMPHDR bfh;

typedef struct
{ 
    unsigned int biSize; 
    unsigned int biWidth; 
    unsigned int biHeight; 
    unsigned short biPlanes; 
    unsigned short biBitCount; 
    unsigned int biCompression; 
    unsigned int biSizeImage; 
    unsigned int biXPelsPerMeter; 
    unsigned int biYPelsPerMeter; 
    unsigned int biClrUsed; 
    unsigned int biClrImportant; 
}
__attribute__((packed))BMPINFHDR;

BMPINFHDR bifo;

SDL_Surface *loadedImage[3];
SDL_Surface *tempImage;
SDL_Surface *screen;
SDL_Rect crop;
SDL_Rect loc;

const SDL_VideoInfo *info; 

char  *dataInvert;
char  *dataOut;
char  *sdldata[2];

char   BMPfile[20][20];
int     imageDim[20];
int     fileSize[20];

int     oneORtwo;
int     g;
int     handle;
int     scrollTime = 2;
int     runs = 11;
int     retint;

char  msg[180];

char  title[5][30];
char  xtra[5][5];
int   val[5];
float used;
float maxused;
double msecs;
double mbps;
double ramMB;


FILE    *outfile;
FILE    *infile;


int main(int argc, char** argv)
{
    int i;
    char vdriver[256];
    double totalMB;
    double freeMB;
    int newruns = 0;
    int param1;
    int ogl = 0;
   
    for (i=1; i<7; i=i+1)
    {
       if (argc > i)
       {
          switch (toupper(argv[i][0]))
          {
                case 'S':
                param1 = 0;
                if (argc > i+1)
                {
                   sscanf(argv[i+1],"%d", &param1);
                   i = i + 1;
                   if (param1 > 0)
                   {
                      newruns = param1;
                      if (newruns > 11) newruns = 11;
                   }
                }
                break;
                
                case 'F':
                if (argc > i+1)
                {
                   sscanf(argv[i+1],"%s", filePath);
                   i = i + 1;
                   strcat(filePath, "/");
                }
                break;

                case 'O':
                ogl = 1;
                break;
          }
       }

    }

    strcpy(BMPfile[0],  "B204x204.bmp");
    strcpy(BMPfile[1],  "B288x288.bmp");
    strcpy(BMPfile[2],  "B408x408.bmp");
    strcpy(BMPfile[3],  "B576x576.bmp");
    strcpy(BMPfile[4],  "B816x816.bmp");
    strcpy(BMPfile[5],  "B1k1x1k1.bmp");
    strcpy(BMPfile[6],  "B1k6x1k6.bmp");
    strcpy(BMPfile[7],  "B2k3x2k3.bmp");
    strcpy(BMPfile[8],  "B3k2x3k2.bmp");
    strcpy(BMPfile[9],  "B4k6x4k6.bmp");
    strcpy(BMPfile[10], "B6k5x6k5.bmp");
    strcpy(BMPfile[11], "B9k2x9k2.bmp");
    strcpy(BMPfile[12], "B13kx13k.bmp");
    strcpy(BMPfile[13], "B18k4x18k4.bmp");
       
    imageDim[0]  = 204;   //  0.1 MB
    imageDim[1]  = 288;   //  0.2 MB
    imageDim[2]  = 408;   //  0.5 MB
    imageDim[3]  = 576;   //  1.0 MB
    imageDim[4]  = 816;   //  2.0 MB
    imageDim[5]  = 1152;  //  4.0 MB
    imageDim[6]  = 1632;  //  8.0 MB
    imageDim[7]  = 2304;  //  16  MB
    imageDim[8]  = 3264;  //  32  MB
    imageDim[9]  = 4608;  //  64  MB
    imageDim[10] = 6528;  //  128 MB
    imageDim[11] = 9216;  //  255 MB
    imageDim[12] = 13056; //  510 MB
    imageDim[13] = 18432; // 1020 MB not possible max = 16384

    fileSize[0]  = 126976;
    fileSize[1]  = 249856;
    fileSize[2]  = 499712;    //  runs  1
    fileSize[3]  = 999424;    //        2
    fileSize[4]  = 2097152;   //        3
    fileSize[5]  = 4194304;   //        4
    fileSize[6]  = 8388608;   //        5
    fileSize[7]  = 16777216;  //        6
    fileSize[8]  = 33554432;  //        7
    fileSize[9]  = 67108864;  //        8
    fileSize[10] = 134217728; //        9
    fileSize[11] = 268435456; //       10
    fileSize[12] = 536870912; //       11
    fileSize[13] = 1073741824; //      12
    
    outfile = fopen("bmpSpeed.txt","a+");
    if (outfile == NULL)
    {
        printf ("Cannot open results file \n\n");
        printf(" Press Enter\n");
        g  = getchar();
        exit (0);
    }
    getDetails();
    ramMB = ramGB / 1024;
    runs = 8;
    if (ramGB > 1.9) runs = 11;
    if (ramGB < 1.1) runs = 10;
    if (ramGB < 0.8) runs =  9;
    if (ramGB < 0.6) runs =  8;

    if (newruns > 0) runs = newruns; 
   
    for (i=1; i<10; i++)
    {
        printf("%s\n", configdata[i]);
    }
    fprintf (outfile, " #####################################################################\n\n");
    for (i=1; i<10; i++)
    {
        fprintf(outfile, "%s \n", configdata[i]);
    }
    printf("\n  Memory stats from /proc/meminfo\n\n");
    fprintf(outfile, "\n  Memory stats from /proc/meminfo\n\n");
    if (memused())
    {
        for (i=0; i<4; i++)
        {
            printf("  %12s %8.1f MB   %c\n", title[i], (float)val[i]/1024, i+65);
            fprintf(outfile, "  %12s %8.1f MB   %c\n", title[i], (float)val[i]/1024, i+65);
        }
        printf("\n  Memory Used: %8.1f MB = A - B - C - D\n", used); 
        fprintf(outfile, "\n  Memory Used: %8.1f MB = A - B - C - D\n", used); 
    }
    else
    {
        printf("  Not available\n\n");
        fprintf(outfile, "  Not available\n\n");
    }

    char thispath[PATH_MAX];

    if (strcmp(filePath, "") != 0)
    { 
        printf ("\n  Selected File Path: \n  %s\n", filePath);
        fprintf (outfile, "\n  Selected File Path: \n  %s\n", filePath);
        strcpy(thispath, filePath);
    }
    else
    {
        if (getcwd(thispath, sizeof thispath) == NULL)
        {
            printf("\n  Current Directory Path not available\n");
            fprintf(outfile, "\n  Current Directory Path not available\n");
        }
        else
        {
            printf ("\n  Current Directory Path (getcwd) and drive space (statvfs): \n  %s\n", thispath);
            fprintf (outfile, "\n  Current Directory Path (getcwd) and drive space (statvfs): \n  %s\n", thispath);
        }
    }
    struct statvfs driveSpace;
    if (statvfs(thispath, &driveSpace))
    {
        printf("  Free Drive Space not available - Exit\n");
        fprintf(outfile, "  Free Drive Space not available - Exit\n");
        fclose(outfile);
        printf("  Press Enter\n");
        g  = getchar();
        exit (0);
        return 0;
    }
    else
    {  
      totalMB = (double)driveSpace.f_frsize * (double)driveSpace.f_blocks / 1048576.0;
      freeMB  = (double)driveSpace.f_frsize * (double)driveSpace.f_bfree  / 1048576.0;
      printf ("  Total MB %7.0f, Free MB %7.0f, Used MB %7.0f\n", totalMB, freeMB, totalMB - freeMB);
      fprintf (outfile, "  Total MB %7.0f, Free MB %7.0f, Used MB %7.0f\n", totalMB, freeMB, totalMB - freeMB);
    }
    double MBneeded = (double)fileSize[runs+1]/1000000;
    if (freeMB < MBneeded)
    {
        printf("  Not Enough Free Drive Space "); 
        fprintf(outfile, "  Not Enough Free Drive Space "); 
        runs = 0;
        for (i=1; i<12; i++)
        {
            MBneeded = (double)fileSize[i+1]/1000000;
            if (freeMB > MBneeded) runs = i;
        }
        if (runs == 0)



        {
            printf("- Exit\n");
            fprintf(outfile, "- Exit\n");
            fclose(outfile);
            printf("  Press Enter\n");
            g  = getchar();
            return 0;
        }
        else
        {
            printf("- Will use up to %6.1f MB\n", (double)fileSize[runs+1]/1000000);
        }
    }
    printf ("  See files hd1.txt and hd2.txt for details of drive used\n");
    fprintf (outfile, "  See files hd1.txt and hd2.txt for details of drive used\n");    
    if (SDL_Init(SDL_INIT_EVERYTHING) != 0)
    {
        printf (" SDL_Init Failed\n\n");
        fprintf (outfile, " SDL_Init Failed\n\n");
        fclose(outfile);
        printf(" Press Enter\n");
        g  = getchar();
        return 0;
    }

    info = SDL_GetVideoInfo();

    printf ("\n  SDL_GetVideoInfo\n");
    fprintf (outfile, "\n  SDL_GetVideoInfo\n");

    if (info->hw_available == 0)
    {
        printf ("  hw_available flag is 0 - cannot create hardware surfaces\n");
        fprintf (outfile, "  hw_available flag is 0 - cannot create hardware surfaces\n");
    }
    else
    {
        printf ("  hw_available - can create hardware surfaces\n");
        fprintf (outfile, "  hw_available - can create hardware surfaces\n");
    }
    
    screen = SDL_SetVideoMode( info->current_w, info->current_h, info->vfmt->BitsPerPixel,  SDL_HWSURFACE | SDL_ASYNCBLIT);
    if (screen == NULL)
    { 
        printf ("\n SDL_SetVideoMode Failed\n");
        fprintf (outfile, "\n SDL_SetVideoMode\n");
        fclose(outfile);
        printf(" Press Enter\n");
        SDL_Quit();
        g  = getchar();
        return 0;
    }

    printf ("  Display size %d x %d pixels at %d bits\n", info->current_w, info->current_h, info->vfmt->BitsPerPixel);
    fprintf (outfile, "  Display size %d x %d pixels at %d bits\n", info->current_w, info->current_h, info->vfmt->BitsPerPixel);

    if (SDL_VideoDriverName(vdriver, 256) != NULL)
    {
        printf ("\n  SDL_VideoDriverName = %s\n", vdriver);
        fprintf (outfile, "\n  SDL_VideoDriverName = %s\n", vdriver);
    }
    else
    {
        printf ("\n  VideoDriverName not available\n");
        fprintf (outfile, "\n  VideoDriverName not available\n");
    }
    printf ("\n  Graphics (command - lspci | grep -i vga > vga.txt)\n");
    fprintf (outfile, "\n  Graphics (command - lspci | grep -i vga > vga.txt)\n");

    char acmd[200];
   sprintf(acmd, "date >> hd1.txt");
    g = system(acmd);
   sprintf(acmd, "df /%s >> hd1.txt", filePath);
    g = system(acmd);
   sprintf(acmd, "date >> hd2.txt");
    g = system(acmd);
   sprintf(acmd, "ls -l /dev/disk/by-id >> hd2.txt");
    g = system(acmd);
    sprintf(acmd, "lspci | grep -i vga > vga.txt");
    g = system(acmd);
    infile = fopen("vga.txt","r");
    if (infile == NULL)
    {
        printf ("  Not available\n");
        fprintf (outfile, "  Not available\n");
    }
    else
    {
        if (fgets (acmd, 200, infile) != NULL)
        {
            for (i=0; i<strlen(acmd); i++)
            {
                if (acmd[i] == 'V') break;
            }
            if (i < strlen(acmd))
            { 
                printf ("  %s\n", acmd+i);
                fprintf (outfile, "  %s\n", acmd+i);
            }
            else
            {
                printf ("  Not available\n");
                fprintf (outfile, "  Not available\n");
            }
        }
        else
        {
            printf ("  Not available\n");
            fprintf (outfile, "  Not available\n");
        }
    }
    fclose (infile);

    local_time();
    printf("\n");
    printf(" ##########################################\n"); 
    printf(" Image Editing Speeds %s, %s\n", version, timeday);
    printf("   Input Enlarge    Save    Load  Scroll  Scroll  Rotate  Max MB\n");
    printf("   Image Display         Display  Repeat Overall  90 deg  Memory\n");
    printf("  Mbytes    Secs    Secs    Secs   msecs  MB/Sec    Secs    Used\n\n");

    fprintf(outfile, "\n #####################################################################\n\n");
    fprintf(outfile, "   Image Editing Speeds %s, %s\n", version, timeday);
    fprintf(outfile, "   Input Enlarge    Save    Load  Scroll  Scroll  Rotate  Max MB\n");
    fprintf(outfile, "   Image Display         Display  Repeat Overall  90 deg  Memory\n");
    fprintf(outfile, "  Mbytes    Secs    Secs    Secs   msecs  MB/Sec    Secs    Used\n\n");
    fflush(outfile);

    oneORtwo = 1;
    readBMP(0);
    crop.x = 0;
    crop.y = 0;
    loc.x = 0;
    loc.y = 0;  

    oneORtwo = 2;
    readBMP(1);

    oneORtwo = 1;
    
    for (i=0; i<runs; i++)
    {
        printf (" %7.1f", (float)fileSize[i+2]/1048576);
        fprintf (outfile, " %7.1f", (float)fileSize[i+2]/1048576);
        
        start_time();
        SDL_FillRect(screen, &screen->clip_rect, SDL_MapRGB(screen->format, 255, 255, 255));
        if (retint != 0)
        { 
            printf (" SDL_FillRect Failed\n\n");
            fprintf (outfile, " SDL_FillRect Failed\n\n");
            fclose(outfile);
            printf(" Press Enter\n");
            SDL_FreeSurface(screen);
            SDL_Quit();
            g  = getchar();
            return 0;
        }
        sprintf (msg, " Image Processing Test - Enlarge %6.1f MB Image", (float)fileSize[i]/1000000);
        SDL_WM_SetCaption(msg, NULL);
        enlarge(i);

        retint = SDL_FillRect(screen, &screen->clip_rect, SDL_MapRGB(screen->format, 255, 255, 255));
        if (retint != 0)
        { 
            printf (" SDL_FillRect Failed\n\n");
            fprintf (outfile, " SDL_FillRect Failed\n\n");
            fclose(outfile);
            printf(" Press Enter\n");
            SDL_FreeSurface(screen);
            SDL_Quit();
            g  = getchar();
            return 0;
        }
        sprintf (msg, " Image Processing Test - Display Enlarged %6.1f MB Image", (float)fileSize[i+2]/1000000);
        SDL_WM_SetCaption(msg, NULL);
        displayEnlarged(i+2);   
        end_time();
        printf (" %7.2f", secs);
        fprintf (outfile," %7.2f", secs);
        
        start_time();
        sprintf (msg, " Image Processing Test - Save %6.1f MB Image", (float)fileSize[i+2]/1000000);
        SDL_WM_SetCaption(msg, NULL);
        writeBMP(i+2);
        end_time();
        printf (" %7.2f", secs);
        fprintf (outfile," %7.2f", secs);

        start_time();
        retint = SDL_FillRect(screen, &screen->clip_rect, SDL_MapRGB(screen->format, 255, 255, 255));
        if (retint != 0)
        { 
            printf (" SDL_FillRect Failed\n\n");
            fprintf (outfile, " SDL_FillRect Failed\n\n");
            printf(" Press Enter\n");
            fclose(outfile);
            SDL_FreeSurface(screen);
            SDL_Quit();
            g  = getchar();
            return 0;
        }
        SDL_FreeSurface(loadedImage[oneORtwo - 1]);

        sprintf (msg, " Image Processing Test - Load %6.1f MB Image", (float)fileSize[i+2]/1000000);
        SDL_WM_SetCaption(msg, NULL);
        readBMP(i+2);

        sprintf (msg, " Image Processing Test - Display Loaded %6.1f MB Image", (float)fileSize[i+2]/1000000);
        SDL_WM_SetCaption(msg, NULL);
        retint = SDL_BlitSurface(loadedImage[oneORtwo-1], &crop, screen, &loc);
        if (retint != 0)
        { 
            printf (" SDL_BlitSurface Failed\n\n");
            fprintf (outfile, " SDL_BlitSurface Failed\n\n");
            fclose(outfile);
            printf(" Press Enter\n");
            SDL_FreeSurface(screen);
            SDL_Quit();
            g  = getchar();
            return 0;
        }
        retint = SDL_Flip(screen);
        if (retint != 0)
        { 
            printf (" SDL_Flip Failed\n\n");
            fprintf (outfile, " SDL_Flip Failed\n\n");
            fclose(outfile);
            printf(" Press Enter\n");
            SDL_FreeSurface(screen);
            SDL_Quit();
            g  = getchar();
            return 0;
        }
        end_time();
        printf (" %7.2f", secs);
        fprintf (outfile," %7.2f", secs);

        secs = 0.0;
        scroll(i+2);
        printf (" %7.2f", msecs);
        printf (" %7.2f", mbps);
        fprintf (outfile," %7.2f", msecs);
        fprintf (outfile," %7.2f", mbps);

        sprintf (msg, " Image Processing Test - Delete %6.1f MB Image File", (float)fileSize[i+2]/1000000);
        SDL_WM_SetCaption(msg, NULL);
        sprintf(testFile, "%s%s", filePath, BMPfile[i+2]); 
        remove(testFile);

        start_time();
        retint = SDL_FillRect(screen, &screen->clip_rect, SDL_MapRGB(screen->format, 255, 255, 255));
        if (retint != 0)
        { 
            printf (" SDL_FillRect Failed\n\n");
            fprintf (outfile, " SDL_FillRect Failed\n\n");
            fclose(outfile);
            printf(" Press Enter\n");
            SDL_FreeSurface(screen);
            SDL_Quit();
            g  = getchar();
            return 0;
        }
        sprintf (msg, " Image Processing Test - Rotate %6.1f MB Image", (float)fileSize[i+2]/1000000);
        SDL_WM_SetCaption(msg, NULL);
        rotateRead(i+2);
        end_time();
        printf (" %7.2f", secs);
        fprintf (outfile, " %7.2f", secs);

        if (used > 0)
        {
            printf (" %7.1f", used);
            fprintf (outfile, " %7.1f", used);
        }

        printf ("\n");
        fprintf (outfile, "\n");
        fflush (stdout);
        fflush (outfile);

        if (oneORtwo == 1)
        {
            oneORtwo = 2;
        }
        else
        {
            oneORtwo = 1;
        }            
        SDL_Delay(1000);
    }
    printf ("\n");
    fprintf (outfile, "\n");
    local_time();
    fprintf (outfile, "                   End at %s\n", timeday);

    fprintf(outfile, "\n");
    fflush (outfile);
    fclose(outfile);

    SDL_Delay(2000);
    SDL_FreeSurface(loadedImage[1]);
    SDL_FreeSurface(loadedImage[0]);
    SDL_FreeSurface(screen);
    SDL_Quit();

    return 1;
    
} // main


int displayEnlarged(int this1)
{
    int i;
    int d    = imageDim[this1];
    int w    = oneORtwo - 1;
    int size = d * d * 3;
    
    SDL_FreeSurface(loadedImage[w]);

    loadedImage[w] = SDL_CreateRGBSurface(SDL_HWSURFACE, d, d, 24, 0,0,0,0);
    if (loadedImage[w] == NULL)
    {
        printf (" SDL_CreateRGBSurface failed size %d x %d, oneOr2 %d\n\n", d, d, w);
        fprintf (outfile, " SDL_CreateRGBSurface failed size %d x %d, oneOr2 %d\n\n", d, d, w);
        fclose(outfile);
        printf(" Press Enter\n");
        SDL_FreeSurface(screen);
        SDL_Quit();
        g  = getchar();
        exit (0);
    }

    // Invert Lines
    int destinc = 0;
    int rowlen = d * 3; 
    int srcinc = rowlen * (d - 1);
    for (i=0; i<d; i++)
    {
        memcpy(loadedImage[w]->pixels+destinc, dataOut+54+srcinc, rowlen);
        destinc = destinc + rowlen;
        srcinc = srcinc - rowlen;
    }
    crop.w = d;
    crop.h = d;
                            
    retint = SDL_BlitSurface(loadedImage[oneORtwo-1], &crop, screen, &loc);
    if (retint != 0)
    { 
        printf (" SDL_BlitSurface Failed\n\n");
        fprintf (outfile, " SDL_BlitSurface Failed\n\n");
        fclose(outfile);
        printf(" Press Enter\n");
        SDL_FreeSurface(screen);
        SDL_Quit();
        g  = getchar();
        exit (0);
    }
    retint = SDL_Flip(screen);
    if (retint != 0)
    { 
        printf (" SDL_Flip Failed\n\n");
        fprintf (outfile, " SDL_Flip Failed\n\n");
        fclose(outfile);
        printf(" Press Enter\n");
        SDL_FreeSurface(screen);
        SDL_Quit();
        g  = getchar();
        exit (0);
    }    
    return 1;
    
} // displayEnlarged


int writeBMP(int this1)
{
    bfh.bfType = 0x4d42;
    bfh.bfSize = fileSize[this1];
    bfh.bfReserved = 0;
    bfh.bfOffBits =  54;
 
    bifo.biSize = 40;
    bifo.biWidth  = imageDim[this1];
    bifo.biHeight = imageDim[this1];
    bifo.biPlanes = 1;
    bifo.biBitCount = 24;
    bifo.biCompression = 0;
    bifo.biSizeImage = fileSize[this1] - 54;
    bifo.biXPelsPerMeter = 0;
    bifo.biYPelsPerMeter = 0;
    bifo.biClrUsed = 0;
    bifo.biClrImportant = 0;

    memcpy(dataOut, &bfh, 14);
    memcpy(dataOut+14, &bifo, 40);
    sprintf(testFile, "%s%s", filePath, BMPfile[this1]);     
    handle = open(testFile, O_WRONLY | O_CREAT | O_TRUNC | O_DIRECT,
                          S_IRUSR | S_IWUSR | S_IRGRP | S_IWGRP );
    if (handle == -1)
    {
        printf (" Cannot open data file for writing\n\n");
        fprintf (outfile, " Cannot open data file for writing\n\n");
        fclose(outfile);
        printf(" Press Enter\n");
        SDL_FreeSurface(screen);
        SDL_Quit();
        g  = getchar();
        exit (0);
    }


    int got = write(handle, dataOut, fileSize[this1]);
    if (got != fileSize[this1])
    {
        printf (" Data size %d  Error writing file\n\n", got);
        fprintf (outfile, " Data size %d  Error writing file\n\n", got);
        close(handle);
        fclose(outfile);
        printf(" Press Enter\n");
        SDL_FreeSurface(screen);
        SDL_Quit();
        g  = getchar();
        exit (0);
    }
    close(handle);
    _mm_free(dataOut);    

    return 1;
    
} // writeBMP

int readBMP(int this1)
{
    int w = oneORtwo - 1;
    crop.w = imageDim[this1];
    crop.h = imageDim[this1];
    sprintf(testFile, "%s%s", filePath, BMPfile[this1]);     
    loadedImage[w] = SDL_LoadBMP(testFile);
    if (!loadedImage[w])
    {
        printf ("  Error reading file %s\n", testFile);
        fprintf (outfile, "  Error reading file %s\n", testFile);
        fclose(outfile);
        printf(" Press Enter\n");
        SDL_FreeSurface(screen);
        SDL_Quit();
        g  = getchar();
        exit (0);
    }
    return 1;
    
} // readBMP


int enlarge(int this1)
{
    int i, j, c, n, p, q;
    uint8_t b1, b2, b3;
    uint8_t b4, b5, b6;
    uint8_t b7, b8, b9;
    uint8_t ba, bb, bc;
    uint8_t e1, e2, e3;
    uint8_t f1, f2, f3;
    char *in;
    char *out;
    int s = oneORtwo - 1;

    dataInvert = (char*)_mm_malloc(fileSize[this1], 512);
    if (dataInvert == NULL)
    {
            printf (" _mm_malloc Failed\n\n");
            fprintf (outfile, " _mm_malloc Failed\n\n");
            fclose(outfile);
            printf(" Press Enter\n");
            SDL_FreeSurface(screen);
            SDL_Quit();
            g  = getchar();
            exit (0);
    }
    sdldata[s] = (char *)loadedImage[s]->pixels;
    
    // Invert Lines
    int destinc = 54;
    int rowlen = imageDim[this1] * 3; 
    int srcinc = rowlen * (imageDim[this1] - 1);
    for (i=0; i<imageDim[this1]; i++)
    {
        memcpy(dataInvert+destinc, sdldata[s]+srcinc, rowlen);
        destinc = destinc + rowlen;
        srcinc = srcinc - rowlen;
    }
    dataOut = (char*)_mm_malloc(fileSize[this1+2], 512);
    if (dataOut == NULL)
    {
            printf (" _mm_malloc Failed\n\n");
            fprintf (outfile, " _mm_malloc Failed\n\n");
            fclose(outfile);
            printf(" Press Enter\n");
            SDL_FreeSurface(screen);
            SDL_Quit();
            g  = getchar();
            exit (0);
    }

    in  = (char*)(dataInvert + 54);
    out = (char*)(dataOut + 54);

    
    c = 0;
    n = 0;
    p = imageDim[this1] * 6;
    q = imageDim[this1] * 3;


    for (i=0; i<imageDim[this1]-1; i++)
    {
        for (j=0; j<imageDim[this1]-1; j++)
        {
            b1 = in[c];
            b2 = in[c+1];
            b3 = in[c+2];

            e1 = in[c+3];
            e2 = in[c+4];
            e3 = in[c+5];

            f1 = in[c+q];
            f2 = in[c+1+q];
            f3 = in[c+2+q];

            b4 = b1 / 2 + e1 / 2;
            b5 = b2 / 2 + e2 / 2;
            b6 = b3 / 2 + e3 / 2;

            b7 = b1 / 2 + f1 / 2;
            b8 = b2 / 2 + f2 / 2;
            b9 = b3 / 2 + f3 / 2;

            ba = f1 / 2 + e1 / 2;
            bb = f2 / 2 + e2 / 2;
            bc = f3 / 2 + e3 / 2;

            c  = c + 3;
            out[n]     = b1;
            out[n+1]   = b2;
            out[n+2]   = b3;
            out[n+3]   = b4;
            out[n+4]   = b5;
            out[n+5]   = b6;
            out[n+p]   = b7;
            out[n+1+p] = b8;
            out[n+2+p] = b9;
            out[n+3+p] = ba;
            out[n+4+p] = bb;
            out[n+5+p] = bc;
            n = n + 6;
        }
        b4 = in[c];
        b5 = in[c+1];
        b6 = in[c+2];

        e1 = in[c-3];
        e2 = in[c-2];
        e3 = in[c-1];

        f1 = in[c+q];
        f2 = in[c+1+q];
        f3 = in[c+2+q];

        b1 = b4 / 2 + e1 / 2;
        b2 = b5 / 2 + e2 / 2;
        b3 = b6 / 2 + e3 / 2;

        ba = b4 / 2 + f1 / 2;
        bb = b5 / 2 + f2 / 2;
        bc = b6 / 2 + f3 / 2;

        b7 = f1 / 2 + e1 / 2;
        b8 = f2 / 2 + e2 / 2;
        b9 = f3 / 2 + e3 / 2;

        c  = c + 3;
        out[n]     = b1;
        out[n+1]   = b2;
        out[n+2]   = b3;
        out[n+3]   = b4;
        out[n+4]   = b5;
        out[n+5]   = b6;
        out[n+p]   = b7;
        out[n+1+p] = b8;
        out[n+2+p] = b9;
        out[n+3+p] = ba;
        out[n+4+p] = bb;
        out[n+5+p] = bc;
        n = n + p + 6;
    }
  
    for (j=0; j<imageDim[this1]-1; j++)
    {
        b1 = in[c];
        b2 = in[c+1];
        b3 = in[c+2];

        e1 = in[c+3];
        e2 = in[c+4];
        e3 = in[c+5];

        f1 = in[c-q];
        f2 = in[c-q+1];
        f3 = in[c-q+2];

        b4 = b1 / 2 + e1 / 2;
        b5 = b2 / 2 + e2 / 2;
        b6 = b3 / 2 + e3 / 2;

        b7 = b1 / 2 + f1 / 2;
        b8 = b2 / 2 + f2 / 2;
        b9 = b3 / 2 + f3 / 2;

        ba = f1 / 2 + e1 / 2;
        bb = f2 / 2 + e2 / 2;
        bc = f3 / 2 + e3 / 2;

        c  = c + 3;

        out[n]     = b7;
        out[n+1]   = b8;
        out[n+2]   = b9;        
        out[n+3]   = ba;
        out[n+4]   = bb;
        out[n+5]   = bc;
        out[n+p]   = b1;
        out[n+1+p] = b2;
        out[n+2+p] = b3;
        out[n+3+p] = b4;
        out[n+4+p] = b5;
        out[n+5+p] = b6;

        n = n + 6;
    }

    b1 = in[c];
    b2 = in[c+1];
    b3 = in[c+2];

    out[n]     = b1;
    out[n+1]   = b2;
    out[n+2]   = b3;
    out[n+3]   = b1;
    out[n+4]   = b2;
    out[n+5]   = b3;
    out[n+p]   = b1;
    out[n+1+p] = b2;
    out[n+2+p] = b3;
    out[n+3+p] = b1;
    out[n+4+p] = b2;
    out[n+5+p] = b3;
    _mm_free(dataInvert);    

    return 1;

} // enlarge


int rotateRead(int this1)
{
    int d1 = imageDim[this1];
    int w  = oneORtwo - 1;

    if (!memused())
    {
        used = 0;
    }
    maxused = used;
    SDL_FreeSurface(tempImage);

    
    loadedImage[2] = SDL_CreateRGBSurface(SDL_HWSURFACE, d1, d1, 24, 0,0,0,0);
    if (loadedImage[2] == NULL)
    {
        printf (" SDL_CreateRGBSurface failed rotateRead\n\n");
        fprintf (outfile, " SDL_CreateRGBSurface failed rotateRead\n\n");
        fclose(outfile);
        printf(" Press Enter\n");
        SDL_FreeSurface(screen);
        SDL_Quit();
        g  = getchar();
        exit (0);
    }

    int  i, j, c, d, e;
    char *in;
    char *out;
    char buf[20];

    out  = (char*)(loadedImage[2]->pixels);
    in   = (char*)(loadedImage[w]->pixels);

    c = 0;
    e = 3 * d1;

    for (i=0; i<d1; i++)
    {
        d = e * (d1 - 1) + i * 3;
        for (j=0; j<d1; j=j+4)
        {
            memcpy(buf, in+c, 12);
            memcpy(out+d, buf, 3);
            d = d - e;
            memcpy(out+d, buf+3, 3);
            d = d - e;
            memcpy(out+d, buf+6, 3);
            d = d - e;
            memcpy(out+d, buf+9, 3);
            d = d - e;
            c = c + 12;
        }
    }

    crop.w = d1;
    crop.h = d1;

    if (!memused())
    {
        used = 0;
    }
    if (maxused > used) used = maxused;
                        
    sprintf (msg, " Image Processing Test - Display Rotated %6.1f MB Image", (float)fileSize[this1]/1000000);
    SDL_WM_SetCaption(msg, NULL);
    retint = SDL_BlitSurface(loadedImage[2], &crop, screen, &loc);
    if (retint != 0)
    { 
        printf (" SDL_BlitSurface Failed\n\n");
        fprintf (outfile, " SDL_BlitSurface Failed\n\n");
        fclose(outfile);
        printf(" Press Enter\n");
        SDL_FreeSurface(screen);
        SDL_Quit();
        g  = getchar();
        exit (0);
    }
    retint = SDL_Flip(screen);
    if (retint != 0)
    { 
        printf (" SDL_Flip Failed\n\n");
        fprintf (outfile, " SDL_Flip Failed\n\n");
        fclose(outfile);
        printf(" Press Enter\n");
        SDL_FreeSurface(screen);
        SDL_Quit();
        g  = getchar();
        exit (0);
    }
    SDL_FreeSurface(loadedImage[2]);
    
    return 1;

} // rotate

int  memused()
{
    int i, r;

    infile = fopen("/proc/meminfo","r");
    if (infile == NULL)
    {
        return 0;
    }
    used = 0;
    if (fscanf(infile, "%s %d %s", title[0], &val[0], xtra[0]) > 0)
    {
        used = (float)val[0]/1024;
    }
    else
    {
        fclose(infile);
        return 0;
    }
    for (i=1; i<4; i++)
    {
        if (fscanf(infile, "%s %d %s", title[i], &val[i], xtra[i]) > 0)
        {
            used = used - (float)val[i]/1024;
        }  
    }
    fclose(infile);
    return 1;

} // memused

int scroll(int this1)
{
    int i;
    int pixlen;
    int count = 0;
    int inc = 1;
    Uint32 imageflags = SDL_SRCCOLORKEY|SDL_RLEACCEL;

    msecs = 0.0;
    mbps = 0;
    
    crop.w = imageDim[this1];
    crop.h = imageDim[this1];

    sprintf (msg, " Image Processing Test - Scroll %6.1f MB Image", (float)fileSize[this1]/1000000);
    SDL_WM_SetCaption(msg, NULL);

    tempImage = SDL_CreateRGBSurface(imageflags, crop.w, crop.h, 32, 0, 0, 0, 0);
    if (tempImage == NULL)
    {
        printf (" SDL_CreateRGBSurface failed\n\n");
        fprintf (outfile, " SDL_CreateRGBSurface failed\n\n");
        fclose(outfile);
        printf(" Press Enter\n");
        SDL_FreeSurface(screen);
        SDL_Quit();
        g  = getchar();
        exit (0);
    }
    retint = SDL_BlitSurface(loadedImage[oneORtwo-1], &crop, tempImage, &loc);
    if (retint != 0)
    { 
        printf (" SDL_BlitSurface Failed\n\n");
        fprintf (outfile, " SDL_BlitSurface Failed\n\n");
        fclose(outfile);
        printf(" Press Enter\n");
        SDL_FreeSurface(screen);
        SDL_Quit();
        g  = getchar();
        exit (0);
    }

    if (imageDim[this1] < info->current_w && imageDim[this1] < info->current_h)
    {
        pixlen = info->current_w - imageDim[this1];
        loc.x = 0;
        loc.y = 0;
        start_time();
        do
        {
            loc.x = loc.x + inc;
            if (loc.x > pixlen  || loc.x == 0) 
            {
                inc = inc * -1;
            }                
            retint = SDL_BlitSurface(tempImage, &crop, screen, &loc);
            if (retint != 0)
            { 
                printf (" SDL_BlitSurface Failed\n\n");
                fprintf (outfile, " SDL_BlitSurface Failed\n\n");
                printf(" Press Enter\n");
                fclose(outfile);
                SDL_FreeSurface(screen);
                SDL_Quit();
                g  = getchar();
                exit (0);
            }
            SDL_UpdateRect(screen, loc.x, 0, crop.w, crop.h);
            count = count + 1;
            end_time();
        }
        while (secs < (double)scrollTime);
        msecs = secs * 1000.0 / (double)count;
        mbps  = (double)fileSize[this1] /1000.0 /msecs;            
        loc.x = 0;            
    }
    else
    {
        crop.w = imageDim[this1];
        if (info->current_w < crop.w) crop.w = info->current_w;
        crop.h = imageDim[this1];
        if (info->current_h < crop.h) crop.h = info->current_h;

        loc.x = 0;
        loc.y = 0;
        crop.y = 0;
        start_time();
        do
        {
            retint = SDL_BlitSurface(tempImage, &crop, screen, &loc);
            if (retint != 0)
            { 
                printf (" SDL_BlitSurface Failed\n\n");
                fprintf (outfile, " SDL_BlitSurface Failed\n\n");
                fclose(outfile);
                printf(" Press Enter\n");
                SDL_FreeSurface(screen);
                SDL_Quit();
                g  = getchar();
                exit (0);
            }
            SDL_UpdateRect(screen, loc.x, 0, crop.w, crop.h);
            crop.y = crop.y + inc;
            if (crop.y + info->current_h > imageDim[this1] || crop.y == 0) inc = inc * -1;          
            count = count + 1;
            end_time();
        }
        while (secs < (double)scrollTime);
        msecs = secs * 1000.0 / (double)count;
        mbps  = (double)crop.w * (double)crop.h * 3.0 /1000.0 /msecs;            
        crop.y = 0;
    }

    return 1;

} // scroll

